/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Liefert die Ellipsen_Schritte, von sek1, x1, y1, nach sek2, x2, y2 um Z lngs X, mit edev enthlt Richtung
QString getEllips( uint mf, double r1, double r2, char *edef, double pr, char s1, double x1, double y1, char s2, double x2, double y2, CircleData *ed )
	{
	unsigned long int S=0, Sy, Sx, X1, X2, Y1, Y2, R1, R2;
	double dx=0, dy=0;
	QString li;
	
	R1 = long( round( r1 * 100 * mf ) );
	R2 = long( round( r2 * 100 * mf ) );
	X1 = long( round( x1 * 100 * mf ) );
	X2 = long( round( x2 * 100 * mf ) );
	Y1 = long( round( y1 * 100 * mf ) );
	Y2 = long( round( y2 * 100 * mf ) );
	
// 	Sectorengrenze-y  ermitteln
	Sy = long( round( R1 * R1 / round( sqrt( R2 * R2 + R1 * R1 ) ) ) );
	
	if( long( R2 * R2) < long( round( Sy * R2 / R1 ) * round( Sy * R2 / R1 ) ) )
		Sx = long( round( sqrt( round( Sy * R2 / R1 ) * round( Sy * R2 / R1 ) - R2 * R2 ) ) );
	else
		Sx = long( round( sqrt( R2 * R2 - long( round( Sy * R2 / R1 ) * round( Sy * R2 / R1 ) ) ) ) );
	
	//KMessageBox::messageBox ( 0, KMessageBox::Information, QString("s1 =  %1\ns2 = %2\nSy = %3\nSx = %4\nR1 = %4\nR2 = %4\nX1 = %4\nY1 = %4").arg(int(s1)).arg(int(s2)).arg(Sy).arg(Sx).arg(R1).arg(R2).arg(X1).arg(Y1), "Info");
	
	if( edef[4] == '1' ) // rechtsrum
		switch(s1)
			{
			case 4:
				if( Y1 < Sy )
					{	//   --- sektor 8 ---
					edef[1] = '0';
					edef[2] = '1';
					edef[3] = '0';
					switch(s2)
						{
						case 4:
							dx = x2 - x1;
							dy = y1 - y2;
							if( Y2 < Sy )
								{	// sektor 8
								if( Y1 == Y2 )
									S = ( 4 * Sy + 4 * Sx );
								if( Y1 < Y2 )
									S = ( Y2 - Y1 );
								if( Y1 > Y2 )
									S = ( ( Sy - Y1 ) + 4 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( ( Sy - Y1 ) + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = - (x2 + x1);
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( ( Sy - Y1 ) + Sx + X2 );
								}
							break;
						case 2:
							dx = - (x2 + x1);
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x2 - x1;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sy - Y1 ) + 4 * Sx + 2 * Sy +  ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( ( Sy - Y1 ) + 3 * Sx + 2 * Sy +  X2 );
								}
						}
					}
				else
					{	//   --- sektor 7 ---
					edef[1] = '1';
					edef[2] = '1';
					edef[3] = '0';
					switch(s2)
						{
						case 4:
							dx = x2 - x1;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( X1 + 3 * Sx + 3 * Sy + Y2 );
								}
							else
								{	// sektor 7
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 > X2 )
									S = ( X1 - X2 );
								if( X1 < X2 )
									S = ( X1 + 3 * Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = - (x2 + x1);
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( X1 +  Sx + ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( X1 + X2 );
								}
							break;
						case 2:
							dx = - (x2 + x1);
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( X1 + Sx + Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( X1 + Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x2 - x1;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( X1 + 3 * Sx + 2 * Sy +  ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( X1 + 2 * Sx + 2 * Sy +  X2 );
								}
						}
					}
				break;
			case 3:
				if( Y1 <= Sy )
					{	//   --- sektor 5 ---
					edef[1] = '0';
					edef[2] = '1';
					edef[3] = '1';
					switch(s2)
						{
						case 4:
							dx = x1 + x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( Y1 + 2 * Sx + 2 * Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( Y1 + 2 * Sx + 3 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								if( Y1 == Y2 )
									S = ( 4 * Sx + 4 * Sy );
								if( Y1 > Y2 )
									S = ( Y1 - Y2 );
								if( Y1 < Y2 )
									S = ( Y1 + 4 * Sx + 3 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( Y1 + 3 * Sx + 3 * Sy + X2 );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( Y1 + Y2 );
								}
							else	// sektor 3
								{
								S = ( Y1 + Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x1 + x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( Y1 + 2 * Sx + Sy + ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( Y1 + Sx + Sy + X2 );
								}
						}
					}
				else
					{	//   --- sektor 6 ---
					edef[1] = '1';
					edef[2] = '1';
					edef[3] = '1';
					switch(s2)
						{
						case 4:
							dx = x1 + x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sx - X1 ) + ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 < X2 )
									S = ( X2 - X1 );
								if( X1 > X2 )
									S = ( ( Sx - X1 ) + 3 * Sx + 4 * Sy + X2 );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sx - X1 ) + Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( ( Sx - X1 ) + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x1 + x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sx - X1 ) + 2 * Sx + 2 * Sy +  ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( ( Sx - X1 ) + Sx + 2 * Sy +  X2 );
								}
						}
					}
				break;
			case 2:
				if( Y1 < Sy )
					{	//   --- sektor 4 ---
					edef[1] = '0';
					edef[2] = '0';
					edef[3] = '1';
					switch(s2)
						{
						case 4:
							dx = x1 + x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sy - Y1 ) + 4 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( ( Sy - Y1 ) + 3 * Sx + 2 *+ Sy +  X2 );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								if( Y1 == Y2 )
									S = ( 4 * Sy + 4 * Sx );
								if( Y1 < Y2 )
									S = ( Y2 - Y1 );
								if( Y1 > Y2 )
									S = ( ( Sy - Y1 ) + 4 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( ( Sy - Y1 ) + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x1 + x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sy - Y1 ) + 2 * Sx + ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( ( Sy - Y1 ) + Sx + X2 );
								}
						}
					}
				else
					{	//   --- sektor 3 ---
					edef[1] = '1';
					edef[2] = '0';
					edef[3] = '1';
					switch(s2)
						{
						case 4:
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							if( Y2 < Sy )	// sektor 8
								{
								S = ( X1 + Sx + Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( X1 + Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( X1 + 3 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( X1 + 2 * Sx + 2 * Sy +  X2 );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( X1 + 3 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 3
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 > X2 )
									S = ( X1 - X2 );
								if( X1 < X2 )
									S = ( X1 + 3 * Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x1 + x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( X1 +  Sx + ( Sy - Y2 ) );
							else	// sektor 2
								{
								S = ( X1 + X2 );
								}
						}
					}
				break;
			case 1:
				if( Y1 <= Sy )
					{	//   --- sektor 1 ---
					edef[1] = '0';
					edef[2] = '0';
					edef[3] = '0';
					switch(s2)
						{
						case 4:
							dx = x2 - x1;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 8
								{
								S = ( Y1 + Y2 );
								}
							else	// sektor 7
								{
								S = ( Y1 + Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = - (x1 + x2);
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( Y1 + 2 * Sx + Sy + ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( Y1 + Sx + Sy + X2 );
								}
							break;
						case 2:
							dx = - (x1 + x2);
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( Y1 + 2 * Sx + 2 * Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( Y1 + 2 * Sx + 3 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x2 - x1;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								{
								if( Y1 == Y2 )
									S = ( 4 * Sx + 4 * Sy );
								if( Y1 > Y2 )
									S = ( Y1 - Y2 );
								if( Y1 < Y2 )
									S = ( Y1 + 4 * Sx + 3 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 2
								{
								S = ( Y1 + 3 * Sx + 3 * Sy + X2 );
								}
						}
					}
				else
					{	//   --- sektor 2 ---
					edef[1] = '1';
					edef[2] = '0';
					edef[3] = '0';
					switch(s2)
						{
						case 4:
							dx = x2 - x1;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sx - X1 ) + Sy + Y2 );
								}
							else	// sektor 7
								{
								S = ( ( Sx - X1 ) + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 3:
							dx = - (x1 + x2);
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 6
								{
								S = ( ( Sx - X1 ) + Sx + 2 * Sy +  X2 );
								}
							break;
						case 2:
							dx = - (x1 + x2);
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 3
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 1:
							dx = x2 - x1;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sx - X1 ) + ( Sy - Y2 ) );
							else	// sektor 2
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 < X2 )
									S = ( X2 - X1 );
								if( X1 > X2 )
									S = ( ( Sx - X1 ) + 3 * Sx + 4 * Sy + X2 );
								}
						}
					}
			}
	
	else // linksrum   ----------------------------------------------------------
		switch(s1)
			{
			case 1:
				if( Y1 < Sy )
					{	//   --- sektor 1---
					edef[1] = '0';
					edef[2] = '0';
					edef[3] = '0';
					switch(s2)
						{
						case 1:
							dx = x2 - x1;
							dy = y2 - y1;
							if( Y2 < Sy )
								{	// sektor 1
								if( Y1 == Y2 )
									S = ( 4 * Sy + 4 * Sx );
								if( Y1 < Y2 )
									S = ( Y2 - Y1 );
								if( Y1 > Y2 )
									S = ( ( Sy - Y1 ) + 4 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 2
								{
								S = ( ( Sy - Y1 ) + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = - (x1 + x2);
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( ( Sy - Y1 ) + Sx + X2 );
								}
							break;
						case 3:
							dx = - (x1 + x2);
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x2 - x1;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sy - Y1 ) + 4 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( ( Sy - Y1 ) + 4 * Sx + 4 * Sy +  X2 );
								}
						}
					}
				else
					{	//   --- sektor 2 ---
					edef[1] = '1';
					edef[2] = '0';
					edef[3] = '0';
					switch(s2)
						{
						case 1:
							dx = x2 - x1;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( X1 + 3 * Sy + 3 * Sx + Y2 );
							else	// sektor 2
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 > X2 )
									S = ( X1 - X2 );
								if( X1 < X2 )
									S = ( X1 + 3 *Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = - (x1 + x2);
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( X1 +  Sx + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( X1 + X2 );
								}
							break;
						case 3:
							dx = - (x1 + x2);
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( X1 + Sx + Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( X1 + Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x2 - x1;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 8
								{
								S = ( X1 + 3 * Sx + 2 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( X1 + 2 * Sx + 2 * Sy + X2 );
								}
						}
					}
				break;
			case 2:
				if( Y1 <= Sy )
					{	//   --- sektor 4 ---
					edef[1] = '0';
					edef[2] = '0';
					edef[3] = '1';
					switch(s2)
						{
						case 1:
							dx = x1 + x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( Y1 + 2 * Sx + 2 * Sy + Y2 );
							else	// sektor 2
								{
								S = ( Y1 + 2 * Sx + 3 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								if( Y1 == Y2 )
									S = ( 4 * Sx + 4 * Sy );
								if( Y1 > Y2 )
									S = ( Y1 - Y2 );
								if( Y1 < Y2 )
									S = ( Y1 + 4 *Sx + 3 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( Y1 + 3 * Sx + 3 * Sy + X2 );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( Y1 + Y2 );
								}
							else	// sektor 6
								{
								S = ( Y1 + Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x1 + x2;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 8
								{
								S = ( Y1 + Sy + 2 * Sx + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( Y1 + Sx + Sy + X2 );
								}
						}
					}
				else
					{	//   --- sektor 3 ---
					edef[1] = '1';
					edef[2] = '0';
					edef[3] = '1';
					switch(s2)
						{
						case 1:
							dx = x1 + x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sx - X1 ) + 2 * Sx + 3 * Sy + Y2 );
							else	// sektor 2
								{
								S = ( ( Sx - X1 ) + 2 *Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y2 - y1;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sx - X1 ) + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 < X2 )
									S = ( X2 - X1 );
								if( X1 > X2 )
									S = ( ( Sx - X1 ) + 3 *Sx + 4 * Sy + X2 );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = - (y1 + y2);
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sx - X1 ) + Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( ( Sx - X1 ) + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 2 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( ( Sx - X1 ) + Sx + 2 * Sy + X2 );
								}
						}
					}
				break;
			case 3:
				if( Y1 < Sy )
					{	//   --- sektor 5 ---
					edef[1] = '0';
					edef[2] = '1';
					edef[3] = '1';
					switch(s2)
						{
						case 1:
							dx = x1 + x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sy - Y1 ) + 2 * Sx + Sy + Y2 );
							else	// sektor 2
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sy - Y1 ) + 4 * Sx + 2 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( ( Sy - Y1 ) + 3 * Sx + 2 * Sy +  X2 );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								if( Y1 == Y2 )
									S = ( 4 * Sy + 4 * Sx );
								if( Y1 < Y2 )
									S = ( Y2 - Y1 );
								if( Y1 > Y2 )
									S = ( ( Sy - Y1 ) + 4 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( ( Sy - Y1 ) + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x1 + x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( ( Sy - Y1 ) + 2 * Sx + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( ( Sy - Y1 ) + Sx + X2 );
								}
						}
					}
				else
					{	//   --- sektor 6 ---
					edef[1] = '1';
					edef[2] = '1';
					edef[3] = '1';
					switch(s2)
						{
						case 1:
							dx = x1 + x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( X1 + Sx + Sy + Y2 );
							else	// sektor 2
								{
								S = ( X1 + Sx + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = x1 - x2;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( X1 + 3 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( X1 + 2 * Sx + 2 * Sy +  X2 );
								}
							break;
						case 3:
							dx = x1 - x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( X1 + 3 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 6
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 > X2 )
									S = ( X1 - X2 );
								if( X1 < X2 )
									S = ( X1 + 3 *Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x1 + x2;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								S = ( X1 +  Sx + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( X1 + X2 );
								}
						}
					}
				break;
			case 4:
				if( Y1 <= Sy )
					{	//   --- sektor 8 ---
					edef[1] = '0';
					edef[2] = '1';
					edef[3] = '0';
					switch(s2)
						{
						case 1:
							dx = x2 - x1;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( Y1 + Y2 );
							else	// sektor 2
								{
								S = ( Y1 + Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = - (x2 + x1);
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( Y1 + 2 * Sx + Sy + ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( Y1 + Sx + Sy + X2 );
								}
							break;
						case 3:
							dx = - (x2 + x1);
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( Y1 + 2 * Sx + 2 * Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( Y1 + 2 * Sx + 3 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x2 - x1;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								if( Y1 == Y2 )
									S = ( 4 * Sx + 4 * Sy );
								if( Y1 > Y2 )
									S = ( Y1 - Y2 );
								if( Y1 < Y2 )
									S = ( Y1 + 4 *Sx + 3 * Sy + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								S = ( Y1 + 3 * Sx + 3 * Sy + X2 );
								}
						}
					}
				else
					{	//   --- sektor 7 ---
					edef[1] = '1';
					edef[2] = '1';
					edef[3] = '0';
					switch(s2)
						{
						case 1:
							dx = x2 - x1;
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 1
								S = ( ( Sx - X1 ) + Sy + Y2 );
							else	// sektor 2
								{
								S = ( ( Sx - X1 ) + 2 * Sy + ( Sx - X2 ) );
								}
							break;
						case 2:
							dx = - (x2 + x1);
							dy = y1 + y2;
							if( Y2 < Sy )	// sektor 4
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 2 * Sy +  ( Sy - Y2 ) );
								}
							else	// sektor 3
								{
								S = ( ( Sx - X1 ) + Sx + 2 * Sy +  X2 );
								}
							break;
						case 3:
							dx = - (x2 + x1);
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 5
								{
								S = ( ( Sx - X1 ) + 2 * Sx + 3 * Sy + Y2 );
								}
							else	// sektor 6
								{
								S = ( ( Sx - X1 ) + 2 *Sx + 4 * Sy + ( Sx - X2 ) );
								}
							break;
						case 4:
							dx = x2 - x1;
							dy = y1 - y2;
							if( Y2 < Sy )	// sektor 8
								{
								edef[2] = '1';
								S = ( ( Sx - X1 ) + ( Sy - Y2 ) );
								}
							else	// sektor 7
								{
								if( X1 == X2 )
									S = ( 4 * Sx + 4 * Sy );
								if( X1 < X2 )
									S = ( X2 - X1 );
								if( X1 > X2 )
									S = ( ( Sx - X1 ) + 3 *Sx + 4 * Sy + X2 );
								}
						}
					}
			}
	
	ed->set_steps( S );
	
	li = " ellipsdev	";
	li += edef;
	li += "\n przision	" + QString::number( pr, 'f', 2 )+"\n";
	if( edef[5] == '0' & edef[6] == '0' )   // around Z
		{
		li += " x	" + QString::number( x1, 'f', 2 )+"\n y	" + QString::number( y1, 'f', 2 )+"\n radius1	" + QString::number( r1, 'f', 2 ) + "\n radius2	" + QString::number( r2, 'f', 2 ) + "\n schritte	" + QString::number( S )+"\n- dx="+QString::number( dx, 'f', 3 )+"  dy="+QString::number( dy, 'f', 3 )+"\n";
		ed->set_deltax( dx );
		ed->set_deltay( dy );
		ed->set_deltaz ( 0 );
		}
	else
	if( edef[5] == '0' & edef[6] == '1' )   // around Y
		{
		li += " x	" + QString::number( x1, 'f', 2 )+"\n z	" + QString::number( y1, 'f', 2 )+"\n radius1	" + QString::number( r1, 'f', 2 ) + "\n radius2	" + QString::number( r2, 'f', 2 ) + "\n schritte	" + QString::number( S )+"\n- dx="+QString::number( dx, 'f', 3 )+"  dz="+QString::number( dy, 'f', 3 )+"\n";
		ed->set_deltax( dx );
		ed->set_deltay( 0 );
		ed->set_deltaz( dy );
		}
	else
	if( edef[5] == '1' & edef[6] == '0' )   // around X
		{
		li += " y	" + QString::number( x1, 'f', 2 )+"\n z	" + QString::number( y1, 'f', 2 )+"\n radius1	" + QString::number( r1, 'f', 2 ) + "\n radius2	" + QString::number( r2, 'f', 2 ) + "\n schritte	" + QString::number( S )+"\n- dy="+QString::number( dx, 'f', 3 )+"  dz="+QString::number( dy, 'f', 3 )+"\n";
		ed->set_deltax( 0 );
		ed->set_deltay( dx );
		ed->set_deltaz( dy );
		}
	
	if( pr > 0 )
		{
		ed->set_n( long( ceil( S / ( pr *100 * mf ) ) ) );
		li += "- n=" + QString::number( ed->n ) + "\n";
		}
	else
		ed->set_n( 0 );
	
	return li;
	}
	
