/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "konturdialog.h"
#include <kfiledialog.h>
#include <kmessagebox.h>
#include <knuminput.h>
#include "historydoubleinput.h"

#include <qstring.h>
#include <qtabwidget.h>
#include <qpainter.h>
#include <qevent.h>
#include <qcheckbox.h>
#include <qtextedit.h>
#include <qlineedit.h>
#include <qstringlist.h>

#include <math.h>

#include "strtonum.h"

Konturdialog::Konturdialog(QWidget *parent, const char *name)
    :kontur(parent, name)
	{
	// Top 82px; next + 48px
	KL = new K_Linie(this); KL->hide(); KL->move( 62, 82 );
	KLx = new K_Liniex(this); KLx->hide(); KLx->move( 62, 130 );
	KLy = new K_Liniey(this); KLy->hide(); KLy->move( 62, 178 );
	KK = new K_Kreis(this); KK->hide(); KK->move( 62, 226 );
	KVrs = new Vorschub(this); KVrs->hide(); KVrs->move( 62, 274 );
	KEl = new K_Ellipse(this); KEl->hide(); KEl->move( 62, 322 );
	KA2 = new K_Aendern(this); KA2->hide(); KA2->move( 62, this->height()-160 );
	
	KFL = new KF_Linear(this); KFL->hide(); KFL->move( 62, 82 );
	KFK = new KF_Kreis(this); KFK->hide(); KFK->move( 62, 130 );
	KFE = new KF_Ellipse(this); KFE->hide(); KFE->move( 62, 178 );
	KA3 = new K_Aendern(this); KA3->hide(); KA3->move( 62, this->height()-160 );
		
	kn=0, kfn=0;
	kontur_file = "Konturen/default.knt";
	kd_minus = &kd1;
	kd = &kd2;
	kd_plus = &kd3;
	
	painter.begin( view_2d );
	
	exitcode = 0xFFFFFFFF;
	lastwidget_2d = KL;
	lastwidget_3d = KFL;
	}

Konturdialog::~Konturdialog()
	{
	painter.end();
	}

void Konturdialog::closeEvent( QCloseEvent *ce )
	{	
	if( editor->isModified() )
		if( KMessageBox::Yes == KMessageBox::questionYesNo( 0, QString("Die Datei %1 wurde verndert !\nSpeichern ?").arg(kontur_file), "Achtung") )
			{
			if( kontur_file == "Konturen/default.knt" )
				kontur_file = KFileDialog::getSaveFileName( QDir::homeDirPath()+QString("/PCNC/Konturen/"), " *.knt| Kontur-Datei (.knt)\n *.nc| PCNC--Datei (.nc)\n *.dxf| CAD-Datei (.dxf)\n  *.*| Alle (*.*)", this, "sichern_als" );
			
			if( kontur_file != "" )
				save();
			 }
	ce->accept();
	}

QWidget* Konturdialog::showclicked( QWidget *clicked, QWidget *lastwidget )
	{
	if( lastwidget->isVisible() )
		{
		if( lastwidget == clicked )
			{
			lastwidget->hide();
			return clicked;
			}
		
		lastwidget->hide();
		clicked->show();
		}
	else
		clicked->show();
	
	return clicked;
	}

void  Konturdialog::save()
	{
	if( kontur_file != "" )
		{
		QFile f1( kontur_file );
		if ( f1.open( IO_WriteOnly | IO_Truncate ) ) 
			{
			QTextStream str1( &f1 );
			str1 << editor->text();
			editor->setModified(FALSE);
			}
		f1.close();
		}
	}

void Konturdialog::resizeEvent( QResizeEvent * re )
	{   // bottom = 45px
	if( re->size().height() < 696 )
		KK->move( 62, re->size().height()-470 );
	else
		KK->move( 62, 226 );
	
	if( re->size().height() < 802 )
		KEl->move( 62, re->size().height()-480 );
	else
		KEl->move( 62, 322 );
	
	KA2->move( 62, re->size().height()-160 );
	
	if( re->size().height() < 638 )
		KFE->move( 62, re->size().height()-460 );
	else
		KFE->move( 62, 178 );
	
	KA3->move( 62, re->size().height()-160 );

	}


void Konturdialog::draw_editor()
	{
	painter.setPen( Qt::blue );
	painter.drawLine ( 20, 20, view_2d->width()/4,  view_2d->height()/2 );
	painter.drawLine ( 60, 20, 80, 60 );
	painter.drawText( view_2d->rect(), AlignCenter, "Hier entsteht dann eine 2D Ansicht der Kontur.\nHier ist eine Baustelle!!!\nIn development!!!" );
	}

void Konturdialog::paintEvent( QPaintEvent *e )
	{
	draw_editor();
	}


void Konturdialog::linie_clicked()
	{
	lastwidget_2d = showclicked( KL, lastwidget_2d );
	draw_editor();
	
	}

void Konturdialog::liniex_clicked()
	{
	lastwidget_2d = showclicked( KLx, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::liniey_clicked()
	{
	lastwidget_2d = showclicked( KLy, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::kreis_clicked()
	{
	lastwidget_2d = showclicked( KK, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::vorschub_clicked()
	{
	lastwidget_2d = showclicked( KVrs, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::ellipse_clicked()
	{
	lastwidget_2d = showclicked( KEl, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::aendern_2d_clicked()
	{
	lastwidget_2d = showclicked( KA2, lastwidget_2d );
	draw_editor();
	}

void Konturdialog::f_linear_clicked()
	{
	lastwidget_3d = showclicked( KFL, lastwidget_3d );
	}

void Konturdialog::f_kreis_clicked()
	{
	lastwidget_3d = showclicked( KFK, lastwidget_3d );
	}

void Konturdialog::f_ellips_clicked()
	{
	lastwidget_3d = showclicked( KFE, lastwidget_3d );
	}

void Konturdialog::aendern_3d_clicked()
	{
	lastwidget_3d = showclicked( KA3, lastwidget_3d );
	}

void Konturdialog::make()
	{
	int n, j, p, loops;
	QString s, sa, sb;

	i = 0;
	n = 0;
	j = 1;
	X = 0;
	Y = 0;
	W = 0;
	loops = 0;
	SOLVED = FALSE;
	kd_plus->VALID = 0;
	kd->VALID = 0;
	kd_minus->VALID = 0;
	s = "etwas";
	elements_count = 0;
	
	
	while ( ! SOLVED )
		{
		bool OK=TRUE;
		
		switch( j )
			{
			case 1: kd_minus = &kd1; kd = &kd2; kd_plus = &kd3; j = 2; break;
			case 2: kd_minus = &kd2; kd = &kd3; kd_plus = &kd1; j = 3; break;
			case 3: kd_minus = &kd3; kd = &kd1; kd_plus = &kd2; j = 1; break;
			}
		
		if( loops == 1 )
			break;
		
		if( s.isEmpty() )
			{
			i = 0;
			loops++;
			}
		
		s = editor->text( i );
		i++;
		s = s.stripWhiteSpace();
		if( ! s.compare( "LINIE" ) )
			{
			elements_count ++;
			kd_plus->element = LINIE;
			kd_plus->line_starts = i - 1;
			kd_plus->VALID = ELEMENT_VALID;
			
			s = editor->text( i );
			i++;
			
			while( s.at(0) == ' ' )
				{
				if( s.at(1) == 'd' && ( s.at(2) == 'X' || s.at(2) == 'x' ) )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->dx = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= DX_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dx = %1").arg( kd_plus->dx ), "Fehler ");
					}
				else
				if( s.at(1) == 'd' && ( s.at(2) == 'Y' || s.at(2) == 'y' ) )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->dy = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= DY_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dy = %1").arg( kd_plus->dy ), "Fehler ");
					}
				else
				if( s.at(1) == 'd' && ( s.at(2) == 'Z' || s.at(2) == 'z' ) );
				else
				if( s.at(1) == 'p' && s.at(2) == 'x' && s.at(3) == '1' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->x1 = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= X1_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("px1 = %1").arg( kd_plus->x1 ), "Fehler ");
					}
				else
				if( s.at(1) == 'p' && s.at(2) == 'y' && s.at(3) == '1' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->y1 = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= Y1_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("py1 = %1").arg( kd_plus->y1 ), "Fehler ");
					}
				else
				if( s.at(1) == 'p' && s.at(2) == 'x' && s.at(3) == '2' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->x2 = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= X2_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("px2 = %1").arg( kd_plus->x2 ), "Fehler ");
					}
				else
				if( s.at(1) == 'p' && s.at(2) == 'y' && s.at(3) == '2' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->y2 = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= Y2_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("py2 = %1").arg( kd_plus->y2 ), "Fehler ");
					}
				else
				if( s.at(1) == 'd' && s.at(2) == 'l' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->dl = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= DL_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dl = %1").arg( kd_plus->dl ), "Fehler ");
					}
				else
				if( s.at(1) == 'w' && s.at(2) == 'e')
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->we = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= WE_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("we = %1").arg( kd_plus->we ), "Fehler ");
					}
				else
				if( s.at(1) == 'w' )
					{
					p = s.find( '	' ) + 1;
					s.remove( 0, p );
					s = s.stripWhiteSpace();
					if( s.isEmpty() )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Es ist hier ein Fehler aufgetreten !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i, editor->paragraphLength( i ) - 1 );
						editor->setFocus();
						return;
						}
					kd_plus->w = s.toDouble(&OK);
					if( !OK )
						{
						KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Die Zahl '%1' konnte nicht entschlsselt werden !").arg( s ), "Fehler ");
						editor->setCursorPosition ( i-1, p );
						return;
						}
					
					kd_plus->VALID |= W_PRESENT;
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("w = %1").arg( kd_plus->w ), "Fehler ");
					}
				s = editor->text( i );
				i++;
				}
			
			i --;
			kd_plus->line_ends = i - 1;
			}
		else
		if( ! s.compare ( "LINIEX" ) )
			{
			;
			}
		else
		if( ! s.compare ( "LINIEY" ) )
			{
			;
			}
		else
		if( ! s.compare ( "LINIEZ" ) )
			{
			;
			}
		else
		if( ! s.compare ( "KREIS" ) )
			{
			;
			}
		else
		if( ! s.compare ( "ELLIPSE" ) )
			{
			;
			}
		else
		if( ! s.compare ( "KREISFUNKTION" ) )
			{
			;
			}
		else
		if( ! s.compare ( "ELLIPSENFUNKTION" ) )
			{
			;
			}
		else
		if( ! s.compare ( "SCHLEIFE{" ) )
			{
			;
			}
		else
		if( ! s.compare ( "}SCHLEIFE" ) )
			{
			;
			}
		else
		if( ! s.compare ( "DELTAKREIS" ) )
			{
			;
			}
		else
		if( ! s.compare ( "DELTAELLIPS" ) )
			{
			;
			}
		else
		if( ! s.compare ( "VORSCHUB" ) )
			{
			
			}
		else
		if( ! s.compare ( "DELTALINEAR" ) )
			{
			;
			}
		else
		if( ! s.compare ( "WERKZEUGWECHSEL" ) )
			{
			;
			}
		else
		if( ! s.compare ( "MEMO" ) )
			{
			;
			}
		else
		if( ! s.compare ( "etwas" ) )
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("%1").arg( s ), "Fehler ");
		else
			{
			if( ! s.isEmpty() )
				{
				KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Der Befehl '%1' konnte nicht entschlsselt werden").arg( s ), "Fehler ");
				editor->setCursorPosition ( i-1, 0 );
				break;
				}
			else
				{
				if( editor->paragraphs() > i | i==1 )
					{
					if( KMessageBox::Yes == KMessageBox::messageBox ( 0, KMessageBox::WarningYesNo, QString("<b>Eine leere Zeile gefunden !<br>Zeile Lschen ?"), "Fehler ") )
						{
						editor->removeParagraph( i-1);
						break;
						}
					else
						break;
					}
				}
			}
		
		calc();
		}
	}



bool Konturdialog::Ldx_x()
	{
	if( kd->VALID & DX_PRESENT )
		return TRUE;

	if( SOLVED == 0 ) // first state, all ellements are solved till now
		{
		if( kd->VALID & X1_PRESENT && kd->VALID & X2_PRESENT )
			{
			kd->dx = kd->x2 - kd->x1;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		if( kd->VALID & X2_PRESENT )
			{
			kd->dx = kd->x2 - X;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("X <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		if( kd_minus->VALID & X2_PRESENT && kd->VALID & X2_PRESENT )
			{
			kd->dx = kd->x2 - kd_minus->x2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x2_minus <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		if( ! kd->element & LINIEX && kd->VALID & W_PRESENT )
			{
			kd->dx = kd->x2 - kd_minus->x2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x2_minus <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		return FALSE;
		}
	
	if( SOLVED == 1 ) // second state, the element couldn't be solved with its given data - the next element has to help
		{
		if( kd->VALID & X1_PRESENT && kd_plus->VALID & X1_PRESENT )
			{
			kd->dx = kd_plus->x1 - kd->x1;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		if( kd_plus->VALID & X1_PRESENT )
			{
			kd->dx = kd_plus->x1 - X;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		return FALSE;
		}
	
	if( SOLVED == 2 ) // third state, checking for special element form help - tangent to a circle by default
		{
		
		}
	}





bool Konturdialog::Ldx_y()
	{
	if( kd->VALID & DX_PRESENT )
		return TRUE;

	if( SOLVED == 0 )
		{
// 		if( kd->VALID & X1_PRESENT && kd->VALID & X2_PRESENT )
// 			{
// 			kd->dx = kd->x2 - kd->x1;
// 			kd->VALID |= DX_PRESENT;
// 			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
// 			return TRUE;
// 			}
// 		
// 		if( kd_minus->VALID & X2_PRESENT && kd->VALID & X2_PRESENT )
// 			{
// 			kd->dx = kd->x2 - kd_minus->x2;
// 			kd->VALID |= DX_PRESENT;
// 			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x2_minus <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
// 			return TRUE;
// 			}
// 		
// 		if( kd->VALID & X2_PRESENT )
// 			{
// 			kd->dx = kd->x2 - X;
// 			kd->VALID |= DX_PRESENT;
// 			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
// 			return TRUE;
// 			}
// 		
		return FALSE;
		}
	
	if( SOLVED == 1 )
		{
		if( kd->VALID & X1_PRESENT && kd_plus->VALID & X1_PRESENT )
			{
			kd->dx = kd_plus->x1 - kd->x1;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		
		if( kd_plus->VALID & X1_PRESENT )
			{
			kd->dx = kd_plus->x1 - X;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		}
	}

bool Konturdialog::Ldy_y()
	{
	
	}

bool Konturdialog::Ldy_x()
	{
	
	}

bool Konturdialog::Ldx_w()
	{
	
	}

bool Konturdialog::Ldx_we()
	{
	
	}

bool Konturdialog::Ldy_w()
	{
	
	}

bool Konturdialog::Ldy_we()
	{
	
	}


bool Konturdialog::cldx()
	{
	if( kd->VALID & DX_PRESENT )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dx = present"), "Fehler ");
		return TRUE;
		}
	
	if( kd->VALID & X2_PRESENT ) // Could dx be solved with kd->x2 ?
		{
		if( kd->VALID & X1_PRESENT )
			{
			kd->dx = kd->x2 - kd->x1;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		else
		if( kd_minus->VALID & X2_PRESENT )
			{
			kd->dx = kd->x2 - kd_minus->x2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x2_minus <-> x2\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		else
			{
			kd->dx = kd->x2 - X;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("X = %1 <-> x2\ndx = %2").arg(X).arg(kd->dx), "Fehler ");
			return TRUE;
			}
		}
	else
	if( kd_plus->VALID & X1_PRESENT ) // Else, could dx be solved with kd_plus->x1 ?
		{
		if( kd->VALID & X1_PRESENT )
			{
			kd->dx = kd_plus->x1 - kd->x1;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("x1 <-> plus_x1\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		else
		if( kd_minus->VALID & X2_PRESENT )
			{
			kd->dx = kd->x2 - kd_minus->x2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("minus_x2 <-> plus_x1\ndx = %1").arg(kd->dx), "Fehler ");
			return TRUE;
			}
		else
			{
			kd->dx = kd_plus->x1 - X;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("X = %1 <-> plus_x1\ndx = %2").arg(X).arg(kd->dx), "Fehler ");
			return TRUE;
			}
		}
	return FALSE;
	}

bool Konturdialog::cldy()
	{
	if( kd->VALID & DY_PRESENT )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dy = present"), "Fehler ");
		return TRUE;
		}
	
	if( kd->VALID & Y2_PRESENT ) // Could dy be solved with kd->y2 ?
		{
		if( kd->VALID & Y1_PRESENT )
			{
			kd->dy = kd->y2 - kd->y1;
			kd->VALID |= DY_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("y1 <-> y2\ndy = %1").arg(kd->dy), "Fehler ");
			return TRUE;
			}
		else
		if( kd_minus->VALID & Y2_PRESENT )
			{
			kd->dy = kd->y2 - kd_minus->y2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("minus_y2 <-> y2\ndx = %1").arg(kd->dy), "Fehler ");
			return TRUE;
			}
		else
			{
			kd->dy = kd->y2 - Y;
			kd->VALID |= DY_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Y = %1 <-> y2\ndy = %2").arg(Y).arg(kd->dy), "Fehler ");
			return TRUE;
			}
		}
	else
	if( kd_plus->VALID & Y1_PRESENT ) // Else, could dy be solved with kd_plus->y1 ?
		{
		if( kd->VALID & Y1_PRESENT )
			{
			kd->dy = kd_plus->y1 - kd->y1;
			kd->VALID |= DY_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("y1 <-> plus_y1\ndy = %1").arg(kd->dy), "Fehler ");
			return TRUE;
			}
		else
		if( kd_minus->VALID & Y2_PRESENT )
			{
			kd->dy = kd->y2 - kd_minus->y2;
			kd->VALID |= DX_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("minus_y2 <-> plus_y1\ndx = %1").arg(kd->dy), "Fehler ");
			return TRUE;
			}
		else
			{
			kd->dy = kd_plus->y1 - Y;
			kd->VALID |= DY_PRESENT;
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Y = %1 <-> plus_y1\ndy = %2").arg(Y).arg(kd->dy), "Fehler ");
			return TRUE;
			}
		}
	return FALSE;
	}

bool Konturdialog::clw()
	{
	if( kd->VALID & W_PRESENT )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("w = present"), "Fehler ");
		return TRUE;
		}
	
	if( kd->VALID & WE_PRESENT )
		{
		kd->w = W - kd->we;
		
		if( kd->w < -180 )
			kd->w = kd->w + 360;
		
		if( kd->w > 180 )
			kd->w = kd->w - 360;
		
		kd->VALID |= W_PRESENT;
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("we = %1 ->\nw = %2").arg(kd->we).arg(kd->w), "Fehler ");
		return TRUE;
		}
	
	return FALSE;
	}



void Konturdialog::calc()
	{
	
	if( ! kd->VALID )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Element ist ungltig !"), "Fehler ");
		SOLVED = FALSE;
		return;
		}
	
	if( SOLVED )
		{ // kd_plus can't be used
		}
	else
		{ // All can be used, but kd_minus and kd is yet probed
		
		}
	
	
	// Try to solve the element kd points to, else there is an error
	if( kd->VALID )
		{
		// the first element starts with point ( 0, 0 )
		if( kd->line_starts == 0 && kd->element < KREIS )
			{
			kd->x1 = 0;
			kd->VALID |= X1_PRESENT;
			kd->y1 = 0;
			kd->VALID |= Y1_PRESENT;
			}
		
		switch( kd->element )
			{
			case LINIE:
				if( ! cldx() ) // If dx can't be calculated in first stage
					if( kd->VALID & DL_PRESENT ) // Else, could dx be solved with kd->dl ?
						{
						if( cldy() )
							{
							kd->dx = sqrt( kd->dl * kd->dl - kd->dy * kd->dy );
							kd->VALID |= DX_PRESENT;
							}
						else
						if( clw() ) // if kd->w could be get, maybe with kd->we
							{
							W = kd->w;
							if( kd->w == 0.00 )
								{
								if( ! ( kd->VALID & DY_PRESENT ) )
									{
									kd->dy = 0;
									kd->VALID |= DY_PRESENT;
									}
								kd->dx = kd->dl;
								kd->VALID |= DX_PRESENT;
								}
							else
							if( kd->w == 180.00 || kd->w == -180.00 )
								{
								if( ! ( kd->VALID & DY_PRESENT ) )
									{
									kd->dy = 0;
									kd->VALID |= DY_PRESENT;
									}
								kd->dx = - kd->dl;
								kd->VALID |= DX_PRESENT;
								}
							else
							if( kd->w == 90.00 )
								{
								if( ! ( kd->VALID & DY_PRESENT ) )
									{
									kd->dy = kd->dl;
									kd->VALID |= DY_PRESENT;
									}
								kd->dx = 0;
								kd->VALID |= DX_PRESENT;
								}
							else
							if( kd->w == -90.00 )
								{
								if( ! ( kd->VALID & DY_PRESENT ) )
									{
									kd->dy = - kd->dl;
									kd->VALID |= DY_PRESENT;
									}
								kd->dx = 0;
								kd->VALID |= DX_PRESENT;
								}
							else
								{
								kd->dx = kd->dl * cos( M_PI * W / 180 );
								kd->VALID |= DX_PRESENT;
								}
							
							KMessageBox::messageBox ( 0, KMessageBox::Information, QString("we = %1 ->\nw = %2").arg(kd->we).arg(kd->w), "Fehler ");
							}
						}
// 					else
// 					if( kd->VALID == ELEMENT_VALID + DL_PRESENT && kd_plus->VALID & DL_PRESENT )
// 						if( kd_plus->VALID & X2_PRESENT && kd_plus->VALID & Y2_PRESENT )
// 							{
// 							double dx = kd_plus->x2 - X;
// 							double dy = kd_plus->y2 - Y;
// 							if( ( kd->dl + kd_plus->dl ) > dx  && ( kd->dl + kd_plus->dl ) > dy )
// 								{
// 								double x = sqrt( ( ( kd->dl * kd->dl + kd_plus->dl * kd_plus->dl ) - ( dx * dx + dy * dy ) ) / 2 ) * ( dy / dx );
// 								double d1 = kd->dl - sqrt( ( ( kd->dl * kd->dl + kd_plus->dl * kd_plus->dl ) - ( dx * dx + dy * dy ) ) / 2 );
// 								}
// 							}
				
				if( ! cldy() ) // If dy can't be calculated in first stage
					if( kd->VALID & DL_PRESENT ) // Else, could dx be solved with kd->dl ?
						{
						if( cldx() )
							{
							kd->dy = sqrt( kd->dl * kd->dl - kd->dx * kd->dx );
							kd->VALID |= DY_PRESENT;
							}
						else
						if( clw() ) // if kd->w could be get, maybe with kd->we
							{
							W = kd->w;
							if( kd->w == 0.00 )
								{
								if( ! ( kd->VALID & DX_PRESENT ) )
									{
									kd->dx = kd->dl;
									kd->VALID |= DX_PRESENT;
									}
								kd->dy = 0;
								kd->VALID |= DY_PRESENT;
								}
							else
							if( kd->w == 180.00 || kd->w == -180.00 )
								{
								if( ! ( kd->VALID & DX_PRESENT ) )
									{
									kd->dx = - kd->dl;
									kd->VALID |= DX_PRESENT;
									}
								kd->dy = 0;
								kd->VALID |= DY_PRESENT;
								}
							else
							if( kd->w == 90.00 )
								{
								if( ! ( kd->VALID & DX_PRESENT ) )
									{
									kd->dx = 0;
									kd->VALID |= DX_PRESENT;
									}
								kd->dy = kd->dl;
								kd->VALID |= DY_PRESENT;
								}
							else
							if( kd->w == -90.00 )
								{
								if( ! ( kd->VALID & DX_PRESENT ) )
									{
									kd->dx = 0;
									kd->VALID |= DX_PRESENT;
									}
								kd->dy = - kd->dl;
								kd->VALID |= DY_PRESENT;
								}
							else
								{
								kd->dy = kd->dl * sin( M_PI * W / 180 );
								kd->VALID |= DY_PRESENT;
								}
							}
						}
				
				if( ! ( kd->VALID & DX_PRESENT ) )
					{
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dx konnte nicht berechnet werden !"), "Fehler ");
					editor->setSelection ( kd->line_starts, 0, kd->line_ends, 0 );
					SOLVED = FALSE;
					return;
					}
				
				if( ! ( kd->VALID & DY_PRESENT ) )
					{
					KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dy konnte nicht berechnet werden !"), "Fehler ");
					editor->setSelection ( kd->line_starts, 0, kd->line_ends, 0 );
					SOLVED = FALSE;
					return;
					}
				
				SOLVED = TRUE;
				X += kd->dx;
				Y += kd->dy;
				if( kd->dy > 0 && kd->dx > 0)
					W = 180 * atan( kd->dy / kd->dx ) / M_PI;
				else
				if( kd->dy > 0 && kd->dx < 0)
					W = 180 + 180 * atan( kd->dy / kd->dx ) / M_PI;
				else
				if( kd->dy < 0 && kd->dx < 0)
					W = - 90 + 180 * atan( kd->dy / kd->dx ) / M_PI;
				else
				if( kd->dy < 0 && kd->dx > 0)
					W = 180 * atan( kd->dy / kd->dx ) / M_PI;
				else
				if( kd->dx == 0 && kd->dy > 0 )
					W = 90;
				else
				if( kd->dx == 0 && kd->dy < 0 )
					W = -90;
				else
				if( kd->dy == 0 && kd->dx > 0 )
					W = 0;
				else
				if( kd->dy == 0 && kd->dx < 0 )
					W = 180;
				
				KMessageBox::messageBox ( 0, KMessageBox::Information, QString("dx = %1\ndy = %2\nW = %3").arg(kd->dx).arg(kd->dy).arg(W), "Fehler ");
				
// 				editor->setSelection( kd->line_starts, 0, kd->line_ends, editor->text( kd->line_ends ).length() );
// 				expr = "LINIE\n dX	"+QString::number( kd->dx, 'f', 2 )+"\n dY	"+QString::number( kd->dy, 'f', 2 )+"\n dZ	"+QString::number( 0, 'f', 2 );
// 				editor->insert( expr );
// 				int d = kd->line_starts + 3 - kd->line_ends;
// 				kd->line_ends += d;
// 				kd_plus->line_starts += d;
// 				kd_plus->line_ends += d;
// 				i += d;
				break;
			
			case LINIEX: break;
			case LINIEY: break;
			case LINIEZ: break;
			case KREIS: break;
			case ELLIPSE: break;
			}
		}
	}

void Konturdialog::insert_clicked()
	{
	QString s;
	
	s = "etwas";
	i = 0;
	while ( ! s.isEmpty() )
		{
		s = editor->text( i );
		i++;
		s = s.stripWhiteSpace();
		if( ! s.compare( "LINIE" ) )
			{
			i += 3;
			}
		else
		if( ! s.compare ( "LINIEX" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "LINIEY" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "LINIEZ" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "KREIS" ) )
			{
			i += 6;
			}
		else
		if( ! s.compare ( "ELLIPSE" ) )
			{
			i += 7;
			}
		else
		if( ! s.compare ( "WARTE" ) )
			{
			;
			}
		else
		if( ! s.compare ( "KREISFUNKTION" ) )
			{
			i += 6;
			}
		else
		if( ! s.compare ( "ELLIPSENFUNKTION" ) )
			{
			i += 7;
			}
		else
		if( ! s.compare ( "SCHLEIFE{" ) )
			{
			;
			}
		else
		if( ! s.compare ( "}SCHLEIFE" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "DELTAKREIS" ) )
			{
			;
			}
		else
		if( ! s.compare ( "DELTAELLIPS" ) )
			{
			;
			}
		else
		if( ! s.compare ( "VORSCHUB" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "DELTALINEAR" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "WERKZEUGWECHSEL" ) )
			{
			i += 1;
			}
		else
		if( ! s.compare ( "MEMO" ) )
			{
			i += 2;
			}
		else
		if( ! s.compare ( "etwas" ) )
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("%1").arg( s ), "Fehler ");
		else
			{
			if( ! s.isEmpty() )
				{
				KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Der Befehl '%1' konnte nicht entschlsselt werden").arg( s ), "Fehler ");
				editor->setCursorPosition ( i-1, 0 );
				return;
				}
			else
				{
				if( editor->paragraphs() > i | i==1 )
					{
					if( KMessageBox::Yes == KMessageBox::messageBox ( 0, KMessageBox::WarningYesNo, QString("<b>Eine leere Zeile gefunden !<br>Zeile Lschen ?"), "Fehler ") )
						{
						editor->removeParagraph( i-1);
						break;
						}
					else
						return;
					}
				}
			}
		}
	exitcode = 0;
	close();
	}

void Konturdialog::save_clicked()
	{
	if( kontur_file == "Konturen/default.knt" )
		kontur_file = KFileDialog::getSaveFileName( QDir::homeDirPath()+QString("/PCNC/Konturen/"), " *.knt| Kontur-Datei (.knt)\n *.nc| PCNC--Datei (.nc)\n *.dxf| CAD-Datei (.dxf)\n  *.*| Alle (*.*)", this, "sichern_als" );
	save();
	}

void Konturdialog::file_entered()
	{
	kontur_file = "Konturen/";
	kontur_file += datei->text();
	if( kontur_file != "Konturen/" )
		{
		if( -1 == kontur_file.find(".knt") )
			{
			kontur_file += ".knt";
			datei->setText( kontur_file );
			}
		
		QFile f1( kontur_file );
		if ( f1.open( IO_ReadWrite ) ) 
			{
			QTextStream str1( &f1 );
			editor->setText( str1.read() );
			editor->setModified(FALSE);
			}
		
		f1.close();
		}
	}

void Konturdialog::test_clicked()
	{
	KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Noch nicht programmiert !\nNot implementet yet !"), "Fehler ");
	}

void Konturdialog::file_choice_clicked()
	{
	kontur_file = KFileDialog::getOpenFileName ( QDir::homeDirPath()+QString("/PCNC/Konturen"), " *.knt| Kontur-Datei (.knt)\n *.nc| PCNC--Datei (.nc)\n *.dxf| CAD-Datei (.dxf)\n  *.*| Alle (*.*)", this, "Maschinen-Datei ffnen");
	if( kontur_file != "" )
		{
		QFile f1( kontur_file );
		if ( f1.open( IO_ReadOnly ) ) 
			{
			QTextStream str1( &f1 );
			editor->setText( str1.read() );
			editor->setModified(FALSE);
			datei->setText( kontur_file );
			}
		f1.close();
		}
	}

void Konturdialog::tab_changed()
	{
	if( lastwidget_3d->isVisible() )
		lastwidget_3d = showclicked( lastwidget_3d, lastwidget_3d );
	
	if( lastwidget_2d->isVisible() )
		lastwidget_2d = showclicked( lastwidget_2d, lastwidget_2d );
	
	resize( QSize( width(), height()-1 ) );
	resize( QSize( width(), height()+1 ) );
	}

void Konturdialog::kf_kreis_anwenden_clicked()
	{
	}

void Konturdialog::kf_ellipse_anwenden_clicked()
	{
	}

void Konturdialog::kf_linear_anwenden_cklicked()
	{
	}

void Konturdialog::vs_schlichten_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_schlichten->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_normal_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_normal->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_max_z_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_max_z->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_max_y_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_max_y->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_max_x_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_max_x->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_eintauchen_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_eintauchen->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}
void Konturdialog::vs_bohren_einfuegen_clicked()
	{
	expr = "VORSCHUB\n";
	expr += "mm/min	"+QString::number( KVrs->vs_bohren->value() )+"\n";
	editor->insert( expr );
	KVrs->hide();
	kn=8;
	draw_editor();
	}

void Konturdialog::k_linie_verwenden_clicked()
	{
	expr = "LINIE\n";
	
	if( SOLVED )
		kd_activ = kd;
	else
		kd_activ = kd_plus;
	
	kd_activ->element = LINIE;
	kd_activ->VALID = ELEMENT_VALID;
	
	if( KL->use_px1->isChecked() )
		{
		expr += " px1	"+QString::number( KL->px1->value(), 'f', 2 )+"\n";
		kd_activ->x1 = KL->px1->value();
		kd_activ->VALID |= X1_PRESENT;
		}
	
	if( KL->use_py1->isChecked() )
		{
		expr += " py1	"+QString::number( KL->py1->value(), 'f', 2 )+"\n";
		kd_activ->y1 = KL->py1->value();
		kd_activ->VALID |= Y1_PRESENT;
		}
	
	if( KL->use_px2->isChecked() )
		{
		expr += " px2	"+QString::number( KL->px2->value(), 'f', 2 )+"\n";
		kd_activ->x2 = KL->px2->value();
		kd_activ->VALID |= X2_PRESENT;
		}
	
	if( KL->use_py2->isChecked() )
		{
		expr += " py2	"+QString::number( KL->py2->value(), 'f', 2 )+"\n";
		kd_activ->y2 = KL->py2->value();
		kd_activ->VALID |= Y2_PRESENT;
		}
	
	if( KL->use_dx->isChecked() )
		{
		expr += " dx	"+QString::number( KL->dx->value(), 'f', 2 )+"\n";
		kd_activ->dx = KL->dx->value();
		kd_activ->VALID |= DX_PRESENT;
		}
	
	if( KL->use_dy->isChecked() )
		{
		expr += " dy	"+QString::number( KL->dy->value(), 'f', 2 )+"\n";
		kd_activ->dy = KL->dy->value();
		kd_activ->VALID |= DY_PRESENT;
		}
	
	if( KL->use_dl->isChecked() )
		{
		if( KL->dl->value() == 0 )
			{
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie knnen Lnge nicht verwenden wenn sie 0 ist !"), "Fehler ");
			return;
			}
		expr += " dl	"+QString::number( KL->dl->value(), 'f', 2 )+"\n";
		kd_activ->dl = KL->dl->value();
		kd_activ->VALID |= DL_PRESENT;
		}
	
	if( KL->use_w->isChecked() )
		{
		expr += " w	"+QString::number( KL->w->value(), 'f', 2 )+"\n";
		kd_activ->w = KL->w->value();
		kd_activ->VALID |= W_PRESENT;
		}
	
	if( KL->use_we->isChecked() )
		{
		expr += " we	"+QString::number( KL->we->value(), 'f', 2 )+"\n";
		kd_activ->we = KL->we->value();
		kd_activ->VALID |= WE_PRESENT;
		}
	
	int p, i;
	editor->getCursorPosition( &p, &i );
	kd_activ->line_starts = p;
	editor->insert( expr );
	editor->getCursorPosition ( &p, &i );
	kd_activ->line_ends = p;
	
	calc();
	
	KL->hide();
	kn=0;
	draw_editor();
	}
 
void Konturdialog::k_linie_px1_changed()
	{
	KL->use_px1->setChecked( TRUE );
	}

void Konturdialog::k_linie_py1_changed()
	{
	KL->use_py1->setChecked( TRUE );
	}

void Konturdialog::k_linie_px2_changed()
	{
	KL->use_px2->setChecked( TRUE );
	}

void Konturdialog::k_linie_py2_changed()
	{
	KL->use_py2->setChecked( TRUE );
	}

void Konturdialog::k_linie_dx_changed()
	{
	KL->use_dx->setChecked( TRUE );
	}

void Konturdialog::k_linie_dy_changed()
	{
	KL->use_dy->setChecked( TRUE );
	}

void Konturdialog::k_linie_dl_changed()
	{
	KL->use_dl->setChecked( TRUE );
	}

void Konturdialog::k_linie_w_changed()
	{
	KL->use_w->setChecked( TRUE );
	}

void Konturdialog::k_linie_we_changed()
	{
	KL->use_we->setChecked( TRUE );
	}

void Konturdialog::k_liniex_verwenden_clicked()
	{
	expr = "LINIEX\n";
	if( KLx->use_px1->isChecked() )
		expr += " px1	"+QString::number( KLx->px1->value(), 'f', 2 )+"\n";
	
	if( KLx->use_px2->isChecked() )
		expr += " px2	"+QString::number( KLx->px2->value(), 'f', 2 )+"\n";
	
	if( KLx->dx->value() != 0 )
		expr += " dx	"+QString::number( KLx->dx->value(), 'f', 2 )+"\n";
	
	editor->insert( expr );
	KLx->hide(); kn = 2;
	draw_editor();
	}

void Konturdialog::k_liniex_px1_changed()
	{
	KLx->use_px1->setChecked( TRUE );
	}

void Konturdialog::k_liniex_px2_changed()
	{
	KLx->use_px2->setChecked( TRUE );
	}

void Konturdialog::k_liniey_verwenden_clicked()
	{
	expr = "LINIEY\n";
	if( KLy->use_py1->isChecked() )
		expr += " py1	"+QString::number( KLy->py1->value(), 'f', 2 )+"\n";
	
	if( KLy->use_py2->isChecked() )
		expr += " py2	"+QString::number( KLy->py2->value(), 'f', 2 )+"\n";
	
	if( KLy->dy->value() != 0 )
		expr += " dy	"+QString::number( KLy->dy->value(), 'f', 2 )+"\n";
	
	editor->insert( expr );
	KLy->hide(); kn = 4;
	draw_editor();
	}

void Konturdialog::k_liniey_py1_changed()
	{
	KLy->use_py1->setChecked( TRUE );
	}

void Konturdialog::k_liniey_py2_changed()
	{
	KLy->use_py2->setChecked( TRUE );
	}

void Konturdialog::k_kreis_verwenden_clicked()
	{
	expr = "KREIS\n";
	if( KK->radius->value() != 0 )
		expr += " r	"+QString::number( KK->radius->value(), 'f', 2 )+"\n";
	
	if( KK->use_ws1->isChecked() )
		expr += " ws1	"+QString::number( KK->ws1->value(), 'f', 2 )+"\n";
	
	if( KK->use_ws2->isChecked() )
		expr += " ws2	"+QString::number( KK->ws2->value(), 'f', 2 )+"\n";
	
	if( KK->use_winkel1->isChecked() )
		expr += " w1	"+QString::number( KK->winkel1->value(), 'f', 2 )+"\n";
	
	if( KK->use_winkel2->isChecked() )
		expr += " w2	"+QString::number( KK->winkel2->value(), 'f', 2 )+"\n";
	
	if( KK->use_pmx->isChecked() )
		expr += " pmx	"+QString::number( KK->pmx->value(), 'f', 2 )+"\n";
		
	if( KK->use_pmy->isChecked() )
		expr += " pmy	"+QString::number( KK->pmy->value(), 'f', 2 )+"\n";
	
	
	editor->insert( expr );
	KK->hide();kn = 6;
	draw_editor();
	}

void Konturdialog::k_kreis_ws1_changed()
	{
	KK->use_ws1->setChecked( TRUE );
	}

void Konturdialog::k_kreis_ws2_changed()
	{
	KK->use_ws2->setChecked( TRUE );
	}

void Konturdialog::k_kreis_winkel1_changed()
	{
	KK->use_winkel1->setChecked( TRUE );
	}

void Konturdialog::k_kreis_winkel2_changed()
	{
	KK->use_winkel2->setChecked( TRUE );
	}

void Konturdialog::k_kreis_pmx_changed()
	{
	KK->use_pmx->setChecked( TRUE );
	}

void Konturdialog::k_kreis_pmy_changed()
	{
	KK->use_pmy->setChecked( TRUE );
	}

void Konturdialog::k_ellipse_verwenden_clicked()
	{
	expr = "ELLIPSE\n";
	if( KEl->r1->value() != 0 )
		expr += " r1	"+QString::number( KEl->r1->value(), 'f', 2 )+"\n";
	
	if( KEl->r2->value() != 0 )
		expr += " r2	"+QString::number( KEl->r2->value(), 'f', 2 )+"\n";
	
	if( KEl->use_ws1->isChecked() )
		expr += " ws1	"+QString::number( KEl->ws1->value(), 'f', 2 )+"\n";
	
	if( KEl->use_ws2->isChecked() )
		expr += " ws2	"+QString::number( KEl->ws2->value(), 'f', 2 )+"\n";
	
	if( KEl->use_pmx->isChecked() )
		expr += " pmx	"+QString::number( KEl->pmx->value(), 'f', 2 )+"\n";
		
	if( KEl->use_pmy->isChecked() )
		expr += " pmy	"+QString::number( KEl->pmy->value(), 'f', 2 )+"\n";

	editor->insert( expr );
	KEl->hide(); kn = 10;
	draw_editor();
	}

void Konturdialog::k_ellipse_ws1_changed()
	{
	KEl->use_ws1->setChecked( TRUE );
	}

void Konturdialog::k_ellipse_ws2_changed()
	{
	KEl->use_ws2->setChecked( TRUE );
	}

void Konturdialog::k_ellipse_pmx_changed()
	{
	KEl->use_pmx->setChecked( TRUE );
	}

void Konturdialog::k_ellipse_pmy_changed()
	{
	KEl->use_pmy->setChecked( TRUE );
	}

void Konturdialog::k_aendern_ausfuehren_clicked()
	{
	if( this->dimension->currentPageIndex() == 0 )
		{
		KA2->hide(); kn = 12;
		draw_editor();
		}
	else
		{
		KA3->hide(); kfn = 6;
		}
	}


#include "konturdialog.moc"
