/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   bastl@server                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "werkzeugeview.h"
#include "w_use.h"
 
#include <qcombobox.h> 
#include <qfile.h>
#include <qdir.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qcstring.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include <qevent.h>
#include <qtabwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
 
#include <kmessagebox.h>
#include <knuminput.h>
 
#include <iostream>
#include <cstdlib>
#include <sys/io.h>
#include <unistd.h>
#include <time.h>
#include <math.h>

// using namespace std;


WerkzeugeView::WerkzeugeView(QWidget *parent): Werkzeuge( parent )
	{
	QDir::setCurrent( QDir::homeDirPath()+QString("/PCNC") );
	werkzeuge = "";
	statusb=0;
	GESPEICHERT = TRUE;
	COMBO = TRUE;
	MESSEN = FALSE;
	SELECTED = FALSE;
	aW = -1;
	aM = -1;
	maschinendatei = "maschinen.dat";
	
	QFile f2( maschinendatei );
	if ( f2.open( IO_ReadOnly ) ) 
		{
		QDataStream str( &f2 );
		int i = 0;
		while ( ! str.atEnd()  )
			{
			str >> name;
			m_combo->insertItem( QString( name ), -1 );
			i++;
			f2.at( i * 128 );
			}
		m_combo->insertItem( "Maschinenauswahl", -1 );
		m_combo->setCurrentItem( m_combo->count()-1 );
		if( i == 0 )
			{
			KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Legen Sie erst eine Maschine an, damit sie Werkzeuge benutzen knnen !"), "Fehler ");
			exit(-1);
			}
		}
	else
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Sie haben mglicherweise Ihre Maschinendatei gelscht !\nUm weiter arbeiten zu knnen mssen Sie neue Maschinen anlegen, oder diese Datei wieder herstellen !"), "Fehler ");
		exit(-1);
		}
	f2.close();
	
	if( 0 == getuid() )
		{
		oben = new KProcess;
		*oben << "m1o";
		oben10 = new KProcess;
		*oben10 << "m10o";
		oben100 = new KProcess;
		*oben100 << "m100o";
		unten = new KProcess;
		*unten << "m1u";
		unten10 = new KProcess;
		*unten10 << "m10u";
		unten100 = new KProcess;
		*unten100 << "m100u";
		}
	else
		{
		nach_oben_1->setEnabled( FALSE );
		nach_unten_1->setEnabled( FALSE );
		nach_oben_10->setEnabled( FALSE );
		nach_unten_10->setEnabled( FALSE );
		nach_oben_100->setEnabled( FALSE );
		nach_unten_100->setEnabled( FALSE );
		textroot->setText( "Sie haben keine Root-Rechte. Starten Sie das Werkzeugtool mit Ihrem Root-Passwort !" );
		}
	
	delay.tv_sec = 0;
	delay.tv_nsec = 3500;
	}

WerkzeugeView::~WerkzeugeView()
	{
	}

void WerkzeugeView::closeEvent( QCloseEvent *ce )
	{
	ce->accept();
	if ( ! GESPEICHERT )
		if ( 3 == KMessageBox::messageBox ( 0, KMessageBox::QuestionYesNo, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();
	
	exit( 0 );
	}

void WerkzeugeView::clearall()
	{
	werkzeugname->clear();
	
	w_durchmesser->setValue( 0.00 );
	w_l2->setValue( 0.00 );
	w_l3->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_modul->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_modul->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	
	schrup->setChecked(0);
	schlicht->setChecked(0);
	klein->setChecked(0);
	seitlich_o->setChecked(0);
	seitlich_u->setChecked(0);
	unten_a->setChecked(0);
	unten_m->setChecked(0);
	nach_u->setChecked(0);
	nach_s->setChecked(0);
	nach_o->setChecked(0);
	
	differenz->setValue( 0 );
	
	aW = -1;
	}

void WerkzeugeView::speichern_cklicked()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadOnly | IO_WriteOnly ) ) 
		{
		QDataStream str( &f1 );
		if ( aW != -1 )
			{
			f1.at( aW * 79 );

			Q_INT16 verwendung = 0;
			if ( schrup->isChecked() )
				verwendung = verwendung | F_SCHRUP;
			if ( schlicht->isChecked() )
				verwendung = verwendung | F_SCHLICHT;
			if ( klein->isChecked() )
				verwendung = verwendung | F_FEIN;
			if ( seitlich_o->isChecked() )
				verwendung = verwendung | F_SEITL_OBEN;
			if ( seitlich_u->isChecked() )
				verwendung = verwendung | F_SEITL;
			if ( unten_a->isChecked() )
				verwendung = verwendung | F_UNTEN_AUSSEN;
			if ( unten_m->isChecked() )
				verwendung = verwendung | F_UNTEN_MITTE | F_BOHRER;
			if ( nach_u->isChecked() )
				verwendung = verwendung | F_NACH_UNTEN;
			if ( nach_s->isChecked() )
				verwendung = verwendung | F_NACH_SEITL;
			if ( nach_o->isChecked() )
				verwendung = verwendung | F_NACH_OBEN;
			if ( w_steigung->value() > 0.00 )
				verwendung = verwendung | F_GEWINDE;
			if ( w_modul->value() > 0.00 )
				verwendung = verwendung | F_MODUL;
			if ( w_radius->value() > 0.00 )
				verwendung = verwendung | F_FORM;
			if ( w_radius->value() < 0.00 )
				verwendung = verwendung | F_VIERTELRUND;
			if ( w_winkel->value() != 0.00 )
				verwendung = verwendung | F_WINKEL;
;	
			QCString name = werkzeugname->text().utf8();
			name.resize ( 33 );
			
			str << name << verwendung << w_durchmesser->value() << w_l2->value() << w_l3->value();
			
			if ( verwendung & F_GEWINDE )
				str << w_steigung->value();
			else
			if ( verwendung & F_MODUL )
				str << w_modul->value();
			else
			if ( verwendung & ( F_FORM | F_VIERTELRUND ) )
				str << w_radius->value();
			else
			if ( verwendung & F_WINKEL )
				str << w_winkel->value();
			else
				{
				double d = 0.00;
				str << d;
				}
			delta = differenz->value();
			str << double( delta );
			}
		
		f1.close();
		GESPEICHERT = TRUE;
		}
}

void WerkzeugeView::m_combo_activated()
	{
	if ( ! GESPEICHERT )
		if ( 3 == KMessageBox::messageBox ( 0, KMessageBox::QuestionYesNo, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();
	
	GESPEICHERT = TRUE;
	COMBO = TRUE;
	
	if( ! SELECTED )
		{
		m_combo->removeItem( m_combo->count()-1 );
		SELECTED = TRUE;
		}
	
	QFile f2( maschinendatei );
	if ( f2.open( IO_ReadOnly ) ) 
		{
		QDataStream str( &f2 );
		aM = m_combo->currentItem();
		f2.at( aM * 128 );
		str >> name >> b >> b >> b >> w >> w >> w >> w >> w >> w >> b >> w >> w >> sdat >> wdat;
		werkzeuge = wdat;
		clearall();
		}
	f2.close();
	
	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadWrite ) ) 
		{
		QDataStream str( &f1 );
		int i = 0;
		w_combo->clear();
		w_combo->insertItem( "Neues Werkzeug" );
		while ( ! str.atEnd()  )
			{
			str >> name;
			w_combo->insertItem( "("+QString::number( i )+") "+QString( name ), -1 );
			i++;
			f1.at( i * 79 );
			}
		}
	f1.close();
	}


void WerkzeugeView::w_combo_activated()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( aW == ( w_combo->currentItem() -1) && aW != -1 )
		return;
	
	COMBO = TRUE;
 	if ( ! GESPEICHERT )
		if ( KMessageBox::Yes == KMessageBox::questionYesNo( 0, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();

	GESPEICHERT = TRUE;
	
	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadOnly ) ) 
		{
		QDataStream str( &f1 );
		aW = w_combo->currentItem() -1;
		if ( aW != -1 )
			{
			f1.at( ( aW ) * 79 );

			Q_INT16 verwendung;
			double durchmesser;
			double l2;
			double l3;
			double r_s_m_w;
			double delta_in;
			
 			str >> name >> verwendung >> durchmesser >> l2 >> l3 >> r_s_m_w >> delta_in;
			
			werkzeugname->setText( name );
			w_durchmesser->setValue( durchmesser );
			w_l2->setValue( l2 );
			w_l3->setValue( l3 );
			
			w_radius->setValue( 0.00 );
			w_steigung->setValue( 0.00 );
			w_modul->setValue( 0.00 );
			w_winkel->setValue( 0.00 );
			
			if ( 1 && verwendung & F_GEWINDE )
				w_steigung->setValue( r_s_m_w );
			else
			if ( 1 && verwendung & F_MODUL )
				w_modul->setValue( r_s_m_w );
			else
			if ( 1 && verwendung & ( F_FORM | F_VIERTELRUND ) )
				w_radius->setValue( r_s_m_w );
			else
			if ( 1 && verwendung & F_WINKEL )
				w_winkel->setValue( r_s_m_w );
					
			
			if ( 1 && verwendung & F_SCHRUP )
				schrup->setChecked(1);
			else
				schrup->setChecked(0);
			if ( 1 && verwendung & F_SCHLICHT )
				schlicht->setChecked(1);
			else
				schlicht->setChecked(0);
			if ( 1 && verwendung & F_FEIN )
				klein->setChecked(1);
			else
				klein->setChecked(0);
			if ( 1 && verwendung & F_SEITL_OBEN )
				seitlich_o->setChecked(1);
			else
				seitlich_o->setChecked(0);
			if ( 1 && verwendung & F_SEITL )
				seitlich_u->setChecked(1);
			else
				seitlich_u->setChecked(0);
			if ( 1 && verwendung & F_UNTEN_AUSSEN )
				unten_a->setChecked(1);
			else
				unten_a->setChecked(0);
			if ( 1 && verwendung & F_UNTEN_MITTE )
				unten_m->setChecked(1);
			else
				unten_m->setChecked(0);
			if ( 1 && verwendung & F_NACH_UNTEN )
				nach_u->setChecked(1);
			else
				nach_u->setChecked(0);
			if ( 1 && verwendung & F_NACH_SEITL )
				nach_s->setChecked(1);
			else
				nach_s->setChecked(0);
			if ( 1 && verwendung & F_NACH_OBEN )
				nach_o->setChecked(1);
			else
				nach_o->setChecked(0);
			
			differenz->setValue( int( round( delta_in ) ) );
			}
		else
			{
			clearall();
			aW = w_combo->count() - 1;
			w_combo->insertItem ( "("+QString::number( aW )+") " + "Neu", -1 );
			w_combo->setCurrentItem( aW+1 );
			w_tab->setCurrentPage( 0 );
			werkzeugname->setFocus();
			GESPEICHERT = FALSE;
			}
		}
	f1.close();
	COMBO = FALSE;
	}


void WerkzeugeView::werkzeugname_changed()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if ( aW != -1 )
		w_combo->changeItem ( "("+QString::number( aW )+") " + werkzeugname->text(), aW+1 );
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::double_ischanged()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	GESPEICHERT = COMBO;
	}

	
void WerkzeugeView::radius_changed()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	w_modul->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::steigung_changed()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	w_modul->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::modul_changed()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	w_steigung->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::winkel_changed()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	w_modul->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::check_ischanged()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::referenz_clicked()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	MESSEN = TRUE;
	delta = 0;
	differenz->setValue( delta );
	}

void WerkzeugeView::z100_u()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! unten100->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m100u' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta - 100;
		differenz->setValue( delta );
		}
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::z10_u()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! unten10->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m10u' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta - 10;
		differenz->setValue( delta );
		}
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::z1_u()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! unten->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m1u' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta - 1;
		differenz->setValue( delta );
		}
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::z100_o()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! oben100->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m100o' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta + 100;
		differenz->setValue( delta );
		}
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::z10_o()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! oben10->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m10o' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta + 10;
		differenz->setValue( delta );
		}
	
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::z1_o()
	{
	if( aM == -1 )
		{
		KMessageBox::messageBox ( 0, KMessageBox::Information, QString("Whlen Sie zuerst eine Maschinen aus,\n da die entsprechende Werkzeugdatei geffnet werden kann !"), "Fehler ");
		return;
		}
	
	if( unten100->isRunning() | oben100->isRunning() | unten10->isRunning() | oben10->isRunning() | unten->isRunning() | oben->isRunning() ) return;
	
	if( ! oben->start() )
		{
		KMessageBox::messageBox( 0, KMessageBox::Error, QString("Steuerprogramm `m1o' nicht ausfhrbar !"), "Fehler ");
		return;
		}
	
	if( MESSEN )
		{
		delta = delta + 1;
		differenz->setValue( delta );
		}
		
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::changed()
	{
	GESPEICHERT = COMBO;
	}



#include "werkzeugeview.moc"

