/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   bastl@server                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _WERKZEUGEVIEW_H_
#define _WERKZEUGEVIEW_H_

#include "werkzeuge.h"

#include <kprocess.h>


class WerkzeugeView: public Werkzeuge
	{
	Q_OBJECT
	public:
	WerkzeugeView(QWidget *parent);
	
	~WerkzeugeView();
	
	KProcess *oben;
	KProcess *oben10;
	KProcess *oben100;
	KProcess *unten;
	KProcess *unten10;
	KProcess *unten100;
	
	QCString name, sdat, wdat;
	Q_UINT8 b;
	Q_INT16 w;
	QString werkzeuge, maschinendatei;
	int delta;
	bool GESPEICHERT, MESSEN, COMBO, SELECTED;
	int aW, n, aM;
	uchar statusb;
	timespec delay, rest;
	
	private slots:
	void closeEvent( QCloseEvent* );
	
	
	public slots:
	void clearall();
	virtual void speichern_cklicked();
	virtual void w_combo_activated();
	virtual void m_combo_activated();
	virtual void werkzeugname_changed();
	virtual void modul_changed();
	virtual void steigung_changed();
	virtual void radius_changed();
	virtual void winkel_changed();
	virtual void check_ischanged();
	virtual void double_ischanged();
	virtual void z100_u();
	virtual void z10_u();
	virtual void z1_u();
	virtual void z100_o();
	virtual void z10_o();
	virtual void z1_o();
	virtual void referenz_clicked();
	virtual void changed();
	
	};

#endif // _WERKZEUGEVIEW_H_


